/*********************************************************************/
/*                          Litmus                                   */
/*                                                                   */
/*        Luc Maranget, INRIA Paris-Rocquencourt, France.            */
/*        Susmit Sarkar, University of Cambridge, UK.                */
/*                                                                   */
/*  Copyright 2010 Institut National de Recherche en Informatique et */
/*  en Automatique and the authors. All rights reserved.             */
/*  This file is distributed  under the terms of the Lesser GNU      */
/*  General Public License.                                          */
/*********************************************************************/

#include <stdio.h>
#include <sched.h>
#include "affinity.h"

#if 0
static void pp_set(FILE *fp, cpus_t *p) {
  for (int k = 0 ; k < p->sz ; k++) {
    fprintf(fp," %i", p->cpu[k]) ;
  }
}
#endif



cpus_t *read_affinity(void) {
  cpus_t *r ;
  cpu_set_t mask;
  int sz = 0 ;
  if (sched_getaffinity(0, sizeof(mask), &mask) < 0) {
    err(1,"sched_getaffinity");
  }

  for (int p=0 ; p <  CPU_SETSIZE ; p++) {
    if (CPU_ISSET(p,&mask)) sz++ ;
  }
  r = cpus_create(sz) ;
  for (int p=0, *q=r->cpu ; p <  CPU_SETSIZE ; p++) {
    if (CPU_ISSET(p,&mask)) *q++ = p ;
  }
  return r ;
}

/* Enforcing processor affinity.
   Notice that processor numbers may be negative.
   In that case, affinity setting is ignored */
 
void write_affinity(cpus_t *p) {
  cpu_set_t mask;
  int exists_pos = 0 ;

  CPU_ZERO(&mask) ;
  for (int k = 0 ; k < p->sz ; k++) {
    if (p->cpu[k] >= 0) {
      CPU_SET(p->cpu[k],&mask) ;
      exists_pos = 1 ;
    }
  }
  if  (exists_pos) {
    if (sched_setaffinity(0, sizeof(mask), &mask) < 0) {
      err(1,"sched_setaffinity") ;
    }
  }
}

void write_one_affinity(int a) {
  if (a >= 0) {
    cpu_set_t mask;
    CPU_ZERO(&mask) ;
    CPU_SET(a,&mask) ;
    if (sched_setaffinity(0, sizeof(mask), &mask) < 0) {
      err(1,"sched_setaffnity") ;
    }
  }
}

